#include <iostream>
#include <set>
#include <string>
using namespace std;

#ifdef ALTES_DISTANCE
#include "distance.h"
#endif

int main()
{
    /* Typ der Menge:
     *  - ohne Duplikate
     *  - absteigend sortiert
     */
    typedef multiset<string,greater<string> > StringMultiset;

    StringMultiset menge1;        // leerer Multiset-Container

    /* Elemente 1 bis 6 durcheinander in die Menge einfuegen
     */
    menge1.insert ("richtiger");
    menge1.insert ("dies");
    menge1.insert ("kein");
    menge1.insert ("ist");
    menge1.insert ("satz");

    /* "richtiger" einfuegen und Rueckgabewert auswerten
     */
    StringMultiset::iterator pos;
    pos = menge1.insert("richtiger");
    cout << "\"richtiger\" als " << distance(menge1.begin(),pos) + 1
         << ". Element eingefuegt" << endl;

    /* Iterator ueber alle Elemente wandern lassen
     * und aktuelles Element jeweils ausgeben
     */
    for (pos = menge1.begin(); pos != menge1.end(); ++pos) {
        cout << *pos << ' ';
    }
    cout << endl;

    /* Elemente einem anderen Multiset zuweisen
     */
#ifdef KANN_TEMPLATE_ELEMENTFUNKTIONEN
    multiset<string> menge2(menge1.begin(),menge1.end());
#else
    multiset<string> menge2;
    copy (menge1.begin(), menge1.end(),
          inserter(menge2,menge2.begin()));
#endif
    
    copy (menge2.begin(), menge2.end(),
          ostream_iterator<string>(cout," "));
    cout << endl;

    /* Elemente bis vor "kein" entfernen
     */
    menge2.erase (menge2.begin(), menge2.find("kein"));

    /* "richtiger" entfernen
     */
    int anz;
    anz = menge2.erase ("richtiger");
    cout << anz << " Element(e) entfernt" << endl;

    /* Elemente ausgeben
     */
    copy (menge2.begin(), menge2.end(),
          ostream_iterator<string>(cout," "));
    cout << endl;
}
