#include <string>       // fuer string
#include <fstream>      // fuer Datei-I/O
#include <iomanip>      // fuer setw()
#include <cstdlib>      // fuer exit()
using namespace std;

// Vorwaerts-Deklarationen
void writeCharset (const string& dateiname);
void print (const string& dateiname);

int main ()
{
    writeCharset ("charset.out");
    print ("charset.out");
}

void writeCharset (const string& dateiname)
{
    // Datei oeffnen
    ofstream datei (dateiname.c_str());

    // geklappt ?
    if (! datei) {
        /* Fehlerbehandlung */
        cerr << "kann Datei \"" << dateiname
             << "\" nicht oeffnen" << endl;
        exit (EXIT_FAILURE);
    }

    // Zeichensatz hinausschreiben
    for (int i=32; i<256; i++) {
        datei << "Wert: " << setw(3) << i << "   "
              << "Zeichen: " << static_cast<char>(i) << endl;
    }

}   // Datei wird automatisch geschlossen

void print (const string& dateiname)
{
    // Datei oeffnen
    ifstream datei (dateiname.c_str());

    // geklappt ?
    if (! datei) {
        /* Fehlerbehandlung */
        cerr << "kann Datei \"" << dateiname
             << "\" nicht oeffnen" << endl;
        exit (EXIT_FAILURE);
    }

    // Inhalt ausgeben
    char c;
    while (datei.get(c)) {
        cout.put(c);
    }

}   // Datei wird automatisch geschlossen
